## eln 1.4.0

=== CMakeLists.txt ===
# CMakeLists.txt - Part of NotedELN, (C) Daniel Wagenaar 2021

# NEW BUILD INSTRUCTIONS (as of version 1.3.x)
# Type:
#   cd build
#   cmake ..
# to build ELN.


######################################################################
cmake_minimum_required(VERSION 3.10.0)

######################################################################
# Set the project name and version
project(NotedELN VERSION 1.4.0)
set(CMAKE_PROJECT_HOMEPAGE_URL "http://danielwagenaar.net/eln")

######################################################################
# Specify the C++ standard [must be done _before_ adding executable!]
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_POSITION_INDEPENDENT_CODE ON) # I thought this would do the trick...
if (UNIX) 
  add_compile_options(-fPIC) # ... but in fact, this is required on Linux
endif()

# Qt stuff
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
find_package(Qt5
  COMPONENTS Widgets Network Svg PrintSupport Multimedia MultimediaWidgets
  REQUIRED)

######################################################################
# Add the executables
add_executable(notedeln WIN32 MACOSX_BUNDLE)
add_executable(webgrab WIN32 MACOSX_BUNDLE)

include(src/CMakeLists.txt)
include(webgrab/CMakeLists.txt)

# Libraries to link to - Qt must be mentioned
target_link_libraries(notedeln Qt5::Widgets)
target_link_libraries(notedeln Qt5::Network)
target_link_libraries(notedeln Qt5::Svg)
target_link_libraries(notedeln Qt5::PrintSupport)
target_link_libraries(notedeln Qt5::Multimedia)
target_link_libraries(notedeln Qt5::MultimediaWidgets)

if (WIN32)
  target_link_libraries(notedeln secur32.lib)
endif()

# Produce configuration files
configure_file(src/config.h.in config.h)
configure_file(doc/version.tex.in version.tex)

# Include paths - Qt must be mentioned
target_include_directories(notedeln PUBLIC "${PROJECT_BINARY_DIR}")
target_include_directories(notedeln PUBLIC "${Qt5Widgets_INCLUDE_DIRS}")

######################################################################
# Userguide
if (UNIX AND NOT APPLE)
  include(doc/UseLATEX.cmake)
  add_latex_document(doc/userguide.tex IMAGE_DIRS doc doc/icons
    FORCE_PDF INCLUDE_DIRECTORIES doc)
endif()

######################################################################
# General packaging / installation
set(CPACK_PACKAGE_VENDOR "Daniel Wagenaar")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "NotedELN - an Electronic Lab Notebook")
set(CPACK_PACKAGE_DESCRIPTION
  "NotedELN is an Electronic Lab Notebook that lets you focus on note taking.
NotedELN supports text, images, and basic graphical annotations. 
NotedELN makes safeguarding your notebook entries its number one priority 
and is extremely stable.")
set(CPACK_PACKAGE_EXECUTABLES "notedeln;NotedELN")

if (WIN32)
  # NSIS packaging - to be updated
  include(WinPack.CMakeLists.txt)
  
elseif (APPLE)
  set(CPACK_GENERATOR "DMG") # NYI

  get_target_property(_qmake_executable Qt5::qmake IMPORTED_LOCATION)
  get_filename_component(_qt_bin_dir "${_qmake_executable}" DIRECTORY)
  find_program(MACDEPLOYQT_EXECUTABLE macdeployqt HINTS "${_qt_bin_dir}")
  add_custom_command(TARGET myapp POST_BUILD
    COMMAND "${MACDEPLOYQT_EXECUTABLE}"
    "$<TARGET_FILE_DIR:myapp>/../.."
    -always-overwrite
    COMMENT "Running macdeployqt..."
    )
elseif (UNIX)
  include(UnixInstall.CMakeLists.txt)
  include(DebPack.CMakeLists.txt)
endif()

# Packaging
include(CPack)

=== Makefile ===
# Makefile - Part of NotedELN, (C) Daniel Wagenaar 2021

# This Makefile just documents some generally useful actions.
# Actual build process is through cmake.

######################################################################
# Linux stuff
release: prep-release
	( cd build; cmake --build . )

prep-release:
	mkdir -p build
	( cd build; cmake -DCMAKE_BUILD_TYPE=Release  .. )

debug: prep-debug
	( cd build-debug; cmake --build . )

prep-debug:
	mkdir -p build-debug
	( cd build-debug; cmake -DCMAKE_BUILD_TYPE=Debug .. )

clean:; rm -rf build build-debug

tar:;	git archive -o ../notedeln.tar.gz --prefix=notedeln/ HEAD

######################################################################
# Mac OS stuff - to be updated
macclean:; rm -rf eln.app eln.dmg

macapp: SRC WEBGRAB 
	mkdir -p eln.app/Contents/MacOS
	cp build-webgrab/webgrab eln.app/Contents/MacOS
	cp src/App/elnmac.sh eln.app/Contents/MacOS/
	chmod a+x eln.app/Contents/MacOS/elnmac.sh

macdmg: macapp
	$(QBINPATH)/macdeployqt eln.app -dmg -executable=eln.app/Contents/MacOS/webgrab -executable=eln.app/Contents/MacOS/eln

######################################################################
.PHONY: release prep-release debug prep-debug clean tar macclean macapp macdmg

=== doc/Makefile ===
ALL: noted.1 webgrab.1

%.1: %.1.txt
	a2x --doctype manpage --format manpage --no-xmllint --destination-dir=. $<

=== webgrab/CMakeLists.txt ===
target_link_libraries(webgrab Qt5::Widgets)
target_link_libraries(webgrab Qt5::PrintSupport)
target_link_libraries(webgrab Qt5::Svg)

target_sources(webgrab PRIVATE webgrab/Options.h)
target_sources(webgrab PRIVATE webgrab/Options.cpp)

if (UNIX AND NOT APPLE)
  find_package(Qt5 COMPONENTS WebKit WebKitWidgets REQUIRED)  
  target_sources(webgrab PRIVATE webgrab/Printer.h)
  target_sources(webgrab PRIVATE webgrab/webgrab.cpp)
  target_sources(webgrab PRIVATE webgrab/MozillaPage.cpp)
  target_sources(webgrab PRIVATE webgrab/Printer.cpp)
  target_link_libraries(webgrab Qt5::WebKit)
  target_link_libraries(webgrab Qt5::WebKitWidgets)
else()
  find_package(Qt5 COMPONENTS WebEngine WebEngineWidgets REQUIRED)  
  target_sources(webgrab PRIVATE webgrab/PrinterWE.h)
  target_sources(webgrab PRIVATE webgrab/webgrabWE.cpp)
  target_sources(webgrab PRIVATE webgrab/PrinterWE.cpp)
  target_link_libraries(webgrab Qt5::WebEngine)
  target_link_libraries(webgrab Qt5::WebEngineWidgets)
endif()

=== src/Dialogs/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/Dialogs/AboutBox.h )
target_sources(notedeln PRIVATE src/Dialogs/CloneBookDialog.h )
target_sources(notedeln PRIVATE src/Dialogs/GotoPageDialog.h )
target_sources(notedeln PRIVATE src/Dialogs/NewBookDialog.h )
target_sources(notedeln PRIVATE src/Dialogs/PrintDialog.h )
target_sources(notedeln PRIVATE src/Dialogs/SearchDialog.h )
target_sources(notedeln PRIVATE src/Dialogs/SearchView.h )
target_sources(notedeln PRIVATE src/Dialogs/AboutBox.cpp )
target_sources(notedeln PRIVATE src/Dialogs/CloneBookDialog.cpp )
target_sources(notedeln PRIVATE src/Dialogs/GotoPageDialog.cpp )
target_sources(notedeln PRIVATE src/Dialogs/NewBookDialog.cpp )
target_sources(notedeln PRIVATE src/Dialogs/PrintDialog.cpp )
target_sources(notedeln PRIVATE src/Dialogs/SearchDialog.cpp )
target_sources(notedeln PRIVATE src/Dialogs/SearchView.cpp )
target_sources(notedeln PRIVATE src/Dialogs/CloneBookDialog.ui )
target_sources(notedeln PRIVATE src/Dialogs/NewBookDialog.ui )
target_sources(notedeln PRIVATE src/Dialogs/PrintDialog.ui )

=== src/File/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/File/BackgroundVC.h )
target_sources(notedeln PRIVATE src/File/BookFile.h )
target_sources(notedeln PRIVATE src/File/CachedEntry.h )
target_sources(notedeln PRIVATE src/File/DataFile.h )
target_sources(notedeln PRIVATE src/File/DefaultLocation.h )
target_sources(notedeln PRIVATE src/File/DFBlocker.h )
target_sources(notedeln PRIVATE src/File/Downloader.h )
target_sources(notedeln PRIVATE src/File/EntryFile.h )
target_sources(notedeln PRIVATE src/File/Entry.h )
target_sources(notedeln PRIVATE src/File/ImageLoader.h )
target_sources(notedeln PRIVATE src/File/JSONFile.h )
target_sources(notedeln PRIVATE src/File/JSONParser.h )
target_sources(notedeln PRIVATE src/File/LateNoteFile.h )
target_sources(notedeln PRIVATE src/File/LateNoteManager.h )
target_sources(notedeln PRIVATE src/File/PointerSet.h )
target_sources(notedeln PRIVATE src/File/ResLoader.h )
target_sources(notedeln PRIVATE src/File/RmDir.h )
target_sources(notedeln PRIVATE src/File/SmartURL.h )
target_sources(notedeln PRIVATE src/File/SvgFile.h )
target_sources(notedeln PRIVATE src/File/VersionControl.h )
target_sources(notedeln PRIVATE src/File/VideoFile.h )
target_sources(notedeln PRIVATE src/File/BackgroundVC.cpp )
target_sources(notedeln PRIVATE src/File/CachedEntry.cpp )
target_sources(notedeln PRIVATE src/File/DataFile.cpp )
target_sources(notedeln PRIVATE src/File/DFBlocker.cpp )
target_sources(notedeln PRIVATE src/File/Downloader.cpp )
target_sources(notedeln PRIVATE src/File/Entry.cpp )
target_sources(notedeln PRIVATE src/File/EntryFile.cpp )
target_sources(notedeln PRIVATE src/File/ImageLoader.cpp )
target_sources(notedeln PRIVATE src/File/JSONFile.cpp )
target_sources(notedeln PRIVATE src/File/JSONParser.cpp )
target_sources(notedeln PRIVATE src/File/LateNoteFile.cpp )
target_sources(notedeln PRIVATE src/File/LateNoteManager.cpp )
target_sources(notedeln PRIVATE src/File/PointerSet.cpp )
target_sources(notedeln PRIVATE src/File/ResLoader.cpp )
target_sources(notedeln PRIVATE src/File/RmDir.cpp )
target_sources(notedeln PRIVATE src/File/SvgFile.cpp )
target_sources(notedeln PRIVATE src/File/VersionControl.cpp )
target_sources(notedeln PRIVATE src/File/VideoFile.cpp )

=== src/Items/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/Items/Accents.h )
target_sources(notedeln PRIVATE src/Items/BlockItem.h )
target_sources(notedeln PRIVATE src/Items/DefaultingTextItem.h )
target_sources(notedeln PRIVATE src/Items/Digraphs.h )
target_sources(notedeln PRIVATE src/Items/DragLine.h )
target_sources(notedeln PRIVATE src/Items/FontVariants.h )
target_sources(notedeln PRIVATE src/Items/FootnoteItem.h )
target_sources(notedeln PRIVATE src/Items/FutileMovementInfo.h )
target_sources(notedeln PRIVATE src/Items/GfxBlockItem.h )
target_sources(notedeln PRIVATE src/Items/GfxImageItem.h )
target_sources(notedeln PRIVATE src/Items/GfxLineItem.h )
target_sources(notedeln PRIVATE src/Items/GfxMarkItem.h )
target_sources(notedeln PRIVATE src/Items/GfxNoteItem.h )
target_sources(notedeln PRIVATE src/Items/GfxSketchItem.h )
target_sources(notedeln PRIVATE src/Items/GfxVideoItem.h )
target_sources(notedeln PRIVATE src/Items/HtmlBuilder.h )
target_sources(notedeln PRIVATE src/Items/HtmlParser.h )
target_sources(notedeln PRIVATE src/Items/Item.h )
target_sources(notedeln PRIVATE src/Items/LateNoteItem.h )
target_sources(notedeln PRIVATE src/Items/Latin.h )
target_sources(notedeln PRIVATE src/Items/SearchResItem.h )
target_sources(notedeln PRIVATE src/Items/TableBlockItem.h )
target_sources(notedeln PRIVATE src/Items/TableItemDoc.h )
target_sources(notedeln PRIVATE src/Items/TableItem.h )
target_sources(notedeln PRIVATE src/Items/TeXCodes.h )
target_sources(notedeln PRIVATE src/Items/TextBlockItem.h )
target_sources(notedeln PRIVATE src/Items/TextCursor.h )
target_sources(notedeln PRIVATE src/Items/TextItemDocData.h )
target_sources(notedeln PRIVATE src/Items/TextItemDoc.h )
target_sources(notedeln PRIVATE src/Items/TextItem.h )
target_sources(notedeln PRIVATE src/Items/TextSplitter.h )
target_sources(notedeln PRIVATE src/Items/TitleItem.h )
target_sources(notedeln PRIVATE src/Items/TOCItem.h )
target_sources(notedeln PRIVATE src/Items/Unicode.h )
target_sources(notedeln PRIVATE src/Items/Accents.cpp )
target_sources(notedeln PRIVATE src/Items/BlockItem.cpp )
target_sources(notedeln PRIVATE src/Items/DefaultingTextItem.cpp )
target_sources(notedeln PRIVATE src/Items/Digraphs.cpp )
target_sources(notedeln PRIVATE src/Items/DragLine.cpp )
target_sources(notedeln PRIVATE src/Items/FontVariants.cpp )
target_sources(notedeln PRIVATE src/Items/FootnoteItem.cpp )
target_sources(notedeln PRIVATE src/Items/FutileMovementInfo.cpp )
target_sources(notedeln PRIVATE src/Items/GfxBlockItem.cpp )
target_sources(notedeln PRIVATE src/Items/GfxImageItem.cpp )
target_sources(notedeln PRIVATE src/Items/GfxLineItem.cpp )
target_sources(notedeln PRIVATE src/Items/GfxMarkItem.cpp )
target_sources(notedeln PRIVATE src/Items/GfxNoteItem.cpp )
target_sources(notedeln PRIVATE src/Items/GfxSketchItem.cpp )
target_sources(notedeln PRIVATE src/Items/GfxVideoItem.cpp )
target_sources(notedeln PRIVATE src/Items/HtmlBuilder.cpp )
target_sources(notedeln PRIVATE src/Items/HtmlParser.cpp )
target_sources(notedeln PRIVATE src/Items/Item.cpp )
target_sources(notedeln PRIVATE src/Items/LateNoteItem.cpp )
target_sources(notedeln PRIVATE src/Items/Latin.cpp )
target_sources(notedeln PRIVATE src/Items/SearchResItem.cpp )
target_sources(notedeln PRIVATE src/Items/TableBlockItem.cpp )
target_sources(notedeln PRIVATE src/Items/TableItem.cpp )
target_sources(notedeln PRIVATE src/Items/TableItemDoc.cpp )
target_sources(notedeln PRIVATE src/Items/TeXCodes.cpp )
target_sources(notedeln PRIVATE src/Items/TextBlockItem.cpp )
target_sources(notedeln PRIVATE src/Items/TextCursor.cpp )
target_sources(notedeln PRIVATE src/Items/TextItem.cpp )
target_sources(notedeln PRIVATE src/Items/TextItemDoc.cpp )
target_sources(notedeln PRIVATE src/Items/TextItemDocData.cpp )
target_sources(notedeln PRIVATE src/Items/TextItem_MathMode.cpp )
target_sources(notedeln PRIVATE src/Items/TextSplitter.cpp )
target_sources(notedeln PRIVATE src/Items/TitleItem.cpp )
target_sources(notedeln PRIVATE src/Items/TOCItem.cpp )
target_sources(notedeln PRIVATE src/Items/Unicode.cpp )
target_sources(notedeln PRIVATE src/Items/Digraphs.qrc )
target_sources(notedeln PRIVATE src/Items/Latin.qrc )
target_sources(notedeln PRIVATE src/Items/TeXCodes.qrc )

=== src/Scenes/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/Scenes/BaseScene.h )
target_sources(notedeln PRIVATE src/Scenes/DefaultingQTI.h )
target_sources(notedeln PRIVATE src/Scenes/EntryScene.h )
target_sources(notedeln PRIVATE src/Scenes/FocusProxyCache.h )
target_sources(notedeln PRIVATE src/Scenes/Footstacker.h )
target_sources(notedeln PRIVATE src/Scenes/FrontScene.h )
target_sources(notedeln PRIVATE src/Scenes/Restacker.h )
target_sources(notedeln PRIVATE src/Scenes/Roman.h )
target_sources(notedeln PRIVATE src/Scenes/RoundedRect.h )
target_sources(notedeln PRIVATE src/Scenes/SearchResultScene.h )
target_sources(notedeln PRIVATE src/Scenes/SheetScene.h )
target_sources(notedeln PRIVATE src/Scenes/TOCScene.h )
target_sources(notedeln PRIVATE src/Scenes/BaseScene.cpp )
target_sources(notedeln PRIVATE src/Scenes/DefaultingQTI.cpp )
target_sources(notedeln PRIVATE src/Scenes/EntryScene.cpp )
target_sources(notedeln PRIVATE src/Scenes/FocusProxyCache.cpp )
target_sources(notedeln PRIVATE src/Scenes/Footstacker.cpp )
target_sources(notedeln PRIVATE src/Scenes/FrontScene.cpp )
target_sources(notedeln PRIVATE src/Scenes/Restacker.cpp )
target_sources(notedeln PRIVATE src/Scenes/Roman.cpp )
target_sources(notedeln PRIVATE src/Scenes/RoundedRect.cpp )
target_sources(notedeln PRIVATE src/Scenes/SearchResultScene.cpp )
target_sources(notedeln PRIVATE src/Scenes/SheetScene.cpp )
target_sources(notedeln PRIVATE src/Scenes/TOCScene.cpp )

=== debian/changelog ===
eln (1.4.0-1) unstable; urgency=medium

  * New upstream release
    - quilt patches upstreamed
    - install scalable icon
    - use bitmap icons derived from scalable icon
    - switch from qmake to cmake, simplify debian/rules
    - now with 📺🎥! add build dependency on qtmultimedia5-dev
  * Follow upstream rename to more unique name NotedELN
  * Merge -doc package into main package
  * Patch upstream desktop file: incorrect executable
  * Recommend git, which the notebook can use

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 13 Jul 2021 21:28:53 +0100

eln (1.2.20.3-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper from deprecated 9 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Bump policy version
  * Trim trailing whitespace in debian/changelog
  * Break out manual into separate -doc package
  * Bypass top-level Makefile completely
    - use qmake in source subdirs directly
    - build manual using latexmk
    - generate man pages in subdir
    - install icon bitmaps
  * Use make tricks in debian/rules to allow parallelism
  * Quilt patch to correct upstream spelling error
  * git ignore build deb-ris
  * Update debian/copyright
  * Add uscan support file
  * Rename application icon file to just "eln"
  * Set upstream metadata fields
  * Add self as co-maintainer
  * Official Debian release! (closes: #987620)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 29 Apr 2021 09:23:57 +0100

=== debian/control ===
Source: eln
Section: editors
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Daniel Wagenaar <daw@caltech.edu>,
	   Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13),
		cmake,
		qtbase5-dev (>= 5.5),
		qttools5-dev-tools (>= 5.5), libqt5webkit5-dev (>= 5.5),
		qtmultimedia5-dev (>= 5.5),
		asciidoc (>= 8.6.0), libqt5svg5-dev (>= 5.5),
		xsltproc (>= 1.0),
		docbook-xml (>= 4.0), docbook-xsl (>= 1.0),
		inkscape,
		texlive-latex-base (>= 2017),
		texlive-fonts-recommended (>= 2017),
		texlive-latex-extra (>= 2017),
		texlive-latex-recommended (>= 2017),
		biber
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://www.danielwagenaar.net/eln
Vcs-Git: https://salsa.debian.org/science-team/eln.git
Vcs-Browser: https://salsa.debian.org/science-team/eln

Package: notedeln
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: git
Description: Electronic Lab Notebook called NotedELN
 NotedELN is an electronic lab notebook with an emphasis on solid data
 storage. It is designed for scientists of all stripes, and supports:
 .
  * Taking notes during experiments since it automatically saves your
    input every 10 seconds so that your notes will never be lost;
 .
  * Keeping track of data analysis results since screen shots and
    other graphics can be added to a notebook page by drag-and-drop or
    copy-and-paste;
 .
  * Recording your lit searches, since it will automatically download
    papers from PubMed and archive them with your notebook;
 .
  * Recording your thought processes, since it will never get in the
    way of your typing with arbitrary constraints on input formatting.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=5

%:
	dh $@ --buildsystem=cmake

## eln 1.4.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,11 +8,11 @@
 
 
 ######################################################################
-cmake_minimum_required(VERSION 3.10.0)
+cmake_minimum_required(VERSION 3.11.0)
 
 ######################################################################
 # Set the project name and version
-project(NotedELN VERSION 1.4.0)
+project(NotedELN VERSION 1.4.4)
 set(CMAKE_PROJECT_HOMEPAGE_URL "http://danielwagenaar.net/eln")
 
 ######################################################################
@@ -34,8 +34,8 @@
 
 ######################################################################
 # Add the executables
-add_executable(notedeln WIN32 MACOSX_BUNDLE)
-add_executable(webgrab WIN32 MACOSX_BUNDLE)
+add_executable(notedeln WIN32 MACOSX_BUNDLE src/App/main.cpp)
+add_executable(webgrab WIN32 MACOSX_BUNDLE webgrab/Options.cpp)
 
 include(src/CMakeLists.txt)
 include(webgrab/CMakeLists.txt)

=== src/App/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/App/AlreadyOpen.h )
target_sources(notedeln PRIVATE src/App/App.h )
target_sources(notedeln PRIVATE src/App/AppInstance.h )
target_sources(notedeln PRIVATE src/App/BuildDate.h )
target_sources(notedeln PRIVATE src/App/CachedPointer.h )
target_sources(notedeln PRIVATE src/App/CachedPointer_Impl.h )
target_sources(notedeln PRIVATE src/App/Calltrace.h )
target_sources(notedeln PRIVATE src/App/CrashReport.h )
target_sources(notedeln PRIVATE src/App/CUI.h )
target_sources(notedeln PRIVATE src/App/DeletedItem.h )
target_sources(notedeln PRIVATE src/App/DeletedStack.h )
target_sources(notedeln PRIVATE src/App/ElnAssert.h )
target_sources(notedeln PRIVATE src/App/EProcess.h )
target_sources(notedeln PRIVATE src/App/HtmlOutput.h )
target_sources(notedeln PRIVATE src/App/Mode.h )
target_sources(notedeln PRIVATE src/App/RecentBooks.h )
target_sources(notedeln PRIVATE src/App/SceneBank.h )
target_sources(notedeln PRIVATE src/App/Translate.h )
target_sources(notedeln PRIVATE src/App/UserInfo.h )
target_sources(notedeln PRIVATE src/App/Version.h )
target_sources(notedeln PRIVATE src/App/WebGrab.h )
target_sources(notedeln PRIVATE src/App/AlreadyOpen.cpp )
target_sources(notedeln PRIVATE src/App/App.cpp )
target_sources(notedeln PRIVATE src/App/AppInstance.cpp )
target_sources(notedeln PRIVATE src/App/BuildDate.cpp )
target_sources(notedeln PRIVATE src/App/CachedPointer.cpp )
target_sources(notedeln PRIVATE src/App/Calltrace.cpp )
target_sources(notedeln PRIVATE src/App/CrashReport.cpp )
target_sources(notedeln PRIVATE src/App/CUI.cpp )
target_sources(notedeln PRIVATE src/App/DeletedItem.cpp )
target_sources(notedeln PRIVATE src/App/DeletedStack.cpp )
target_sources(notedeln PRIVATE src/App/ElnAssert.cpp )
target_sources(notedeln PRIVATE src/App/EProcess.cpp )
target_sources(notedeln PRIVATE src/App/HtmlOutput.cpp )
target_sources(notedeln PRIVATE src/App/main.cpp )
target_sources(notedeln PRIVATE src/App/Mode.cpp )
target_sources(notedeln PRIVATE src/App/Printing.cpp )
target_sources(notedeln PRIVATE src/App/RecentBooks.cpp )
target_sources(notedeln PRIVATE src/App/SceneBank.cpp )
target_sources(notedeln PRIVATE src/App/Translate.cpp )
target_sources(notedeln PRIVATE src/App/UserInfo.cpp )
target_sources(notedeln PRIVATE src/App/Version.cpp )
target_sources(notedeln PRIVATE src/App/WebGrab.cpp )
target_sources(notedeln PRIVATE src/App/appicon.qrc )
target_sources(notedeln PRIVATE src/App/conf.qrc )
target_sources(notedeln PRIVATE src/App/trans.qrc )

=== src/Book/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/Book/BookData.h )
target_sources(notedeln PRIVATE src/Book/Catalog.h )
target_sources(notedeln PRIVATE src/Book/Index.h )
target_sources(notedeln PRIVATE src/Book/Notebook.h )
target_sources(notedeln PRIVATE src/Book/Search.h )
target_sources(notedeln PRIVATE src/Book/SearchResult.h )
target_sources(notedeln PRIVATE src/Book/Style.h )
target_sources(notedeln PRIVATE src/Book/TOCEntry.h )
target_sources(notedeln PRIVATE src/Book/TOCFile.h )
target_sources(notedeln PRIVATE src/Book/TOC.h )
target_sources(notedeln PRIVATE src/Book/WordIndex.h )
target_sources(notedeln PRIVATE src/Book/BookData.cpp )
target_sources(notedeln PRIVATE src/Book/Catalog.cpp )
target_sources(notedeln PRIVATE src/Book/Index.cpp )
target_sources(notedeln PRIVATE src/Book/Notebook.cpp )
target_sources(notedeln PRIVATE src/Book/Search.cpp )
target_sources(notedeln PRIVATE src/Book/Style.cpp )
target_sources(notedeln PRIVATE src/Book/TOC.cpp )
target_sources(notedeln PRIVATE src/Book/TOCEntry.cpp )
target_sources(notedeln PRIVATE src/Book/WordIndex.cpp )

=== src/File/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
 target_sources(notedeln PRIVATE src/File/BackgroundVC.cpp )
 target_sources(notedeln PRIVATE src/File/CachedEntry.cpp )
 target_sources(notedeln PRIVATE src/File/DataFile.cpp )
+target_sources(notedeln PRIVATE src/File/DefaultLocation.cpp )
 target_sources(notedeln PRIVATE src/File/DFBlocker.cpp )
 target_sources(notedeln PRIVATE src/File/Downloader.cpp )
 target_sources(notedeln PRIVATE src/File/Entry.cpp )

=== src/Gui/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/Gui/BookSplashItem.h )
target_sources(notedeln PRIVATE src/Gui/Cursors.h )
target_sources(notedeln PRIVATE src/Gui/DefaultSize.h )
target_sources(notedeln PRIVATE src/Gui/EventView.h )
target_sources(notedeln PRIVATE src/Gui/Fonts.h )
target_sources(notedeln PRIVATE src/Gui/LinkHelper.h )
target_sources(notedeln PRIVATE src/Gui/OneLink.h )
target_sources(notedeln PRIVATE src/Gui/PageEditor.h )
target_sources(notedeln PRIVATE src/Gui/PageView.h )
target_sources(notedeln PRIVATE src/Gui/PopLabel.h )
target_sources(notedeln PRIVATE src/Gui/PreviewPopper.h )
target_sources(notedeln PRIVATE src/Gui/SplashScene.h )
target_sources(notedeln PRIVATE src/Gui/SplashView.h )
target_sources(notedeln PRIVATE src/Gui/VideoSlider.h )
target_sources(notedeln PRIVATE src/Gui/BookSplashItem.cpp )
target_sources(notedeln PRIVATE src/Gui/Cursors.cpp )
target_sources(notedeln PRIVATE src/Gui/DefaultSize.cpp )
target_sources(notedeln PRIVATE src/Gui/EventView.cpp )
target_sources(notedeln PRIVATE src/Gui/Fonts.cpp )
target_sources(notedeln PRIVATE src/Gui/LinkHelper.cpp )
target_sources(notedeln PRIVATE src/Gui/OneLink.cpp )
target_sources(notedeln PRIVATE src/Gui/PageEditor.cpp )
target_sources(notedeln PRIVATE src/Gui/PageView.cpp )
target_sources(notedeln PRIVATE src/Gui/PopLabel.cpp )
target_sources(notedeln PRIVATE src/Gui/PreviewPopper.cpp )
target_sources(notedeln PRIVATE src/Gui/SplashScene.cpp )
target_sources(notedeln PRIVATE src/Gui/SplashView.cpp )
target_sources(notedeln PRIVATE src/Gui/VideoSlider.cpp )
target_sources(notedeln PRIVATE src/Gui/style.qrc )

=== src/App/eln.iconset/Makefile ===
all: eln_8x8.png eln_16x16.png eln_22x22.png eln_24x24.png eln_32x32.png eln_48x48.png	\
     eln_64x64.png eln_128x128.png eln_256x256.png eln_512x512.png

eln_%.png: eln_scalable.svg
	inkscape --export-width  $(shell echo $*|sed 's/x.*//') \
		 --export-height $(shell echo $*|sed 's/.*x//') \
		 --export-png $@ $<

# Shell fragment to convert scalable icon to bitmaps:
# in=eln_scalable.svg
# for r in 8 16 22 24 32 48 64 128 256 512 ; do
#     echo $r;
#     res=${r}x${r}
#     out=eln_${res}.png
#     # ImageMagick (convert) messes up the text
#     #convert -geometry ${res} ${in} ${out}
#     # Inkscape gets it right, of course
#     inkscape -w ${r} -h ${r} --export-filename=${out} ${in}
#     # librsvg-2.so.2 (rsvg-convert) messes up the text
#     #rsvg-convert --width ${r} --height ${r} --keep-aspect-ratio ${in} > ${out}
# done

.PHONY: all

=== debian/changelog ===
eln (1.4.6-1) unstable; urgency=medium

  * New upstream release
    - debian desktop file patch has been upstreamed
  * Add magic line to build to work around blhc false positive
  * Bump policy version

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 08 May 2022 22:44:19 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
 		texlive-latex-extra (>= 2017),
 		texlive-latex-recommended (>= 2017),
 		biber
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://www.danielwagenaar.net/eln
 Vcs-Git: https://salsa.debian.org/science-team/eln.git

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,6 @@
 
 %:
 	dh $@ --buildsystem=cmake
+
+execute_before_dh_auto_build:
+	@echo "blhc: ignore-line-regexp: .*/CMakeCXXCompilerABI.cpp.*"

## eln 1.5.0

=== CMakeLists.txt ===
# CMakeLists.txt - Part of NotedELN, (C) Daniel Wagenaar 2021

# NEW BUILD INSTRUCTIONS (as of version 1.3.x)
# Type:
#   cd build
#   cmake ..
# to build ELN.


######################################################################
cmake_minimum_required(VERSION 3.16)

######################################################################
# Set the project name and version
project(NotedELN VERSION 1.5.0)
set(CMAKE_PROJECT_HOMEPAGE_URL "http://danielwagenaar.net/eln")

######################################################################
# Specify the C++ standard [must be done _before_ adding executable!]
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
#set(CMAKE_POSITION_INDEPENDENT_CODE ON) # I thought this would do the trick...
#if (UNIX) 
#  add_compile_options(-fPIC) # ... but in fact, this is required on Linux
#endif()

# Qt stuff
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
find_package(Qt6
  COMPONENTS Widgets Network Svg PrintSupport Multimedia MultimediaWidgets
  REQUIRED)

######################################################################
# Add the executables
add_executable(notedeln WIN32 MACOSX_BUNDLE src/App/main.cpp)
add_executable(webgrab WIN32 webgrab/webgrabWE.cpp)

include(src/CMakeLists.txt)
include(webgrab/CMakeLists.txt)

# Libraries to link to - Qt must be mentioned
target_link_libraries(notedeln Qt6::Widgets)
target_link_libraries(notedeln Qt6::Network)
target_link_libraries(notedeln Qt6::Svg)
target_link_libraries(notedeln Qt6::PrintSupport)
target_link_libraries(notedeln Qt6::Multimedia)
target_link_libraries(notedeln Qt6::MultimediaWidgets)

if (WIN32)
  target_link_libraries(notedeln secur32.lib)
endif()
if (APPLE)
  set(MACOSX_BUNDLE_ICON_FILE eln.icns)
  add_custom_command(TARGET notedeln POST_BUILD
     COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/notedeln.app/Contents/Resources
     COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/src/App/eln.icns
        ${CMAKE_CURRENT_BINARY_DIR}/notedeln.app/Contents/Resources
  )
endif()

# Produce configuration files
configure_file(src/config.h.in config.h)

# Include paths - Qt must be mentioned
target_include_directories(notedeln PUBLIC "${PROJECT_BINARY_DIR}")
target_include_directories(notedeln PUBLIC "${Qt6_INCLUDE_DIRS}")

######################################################################
# Spinx documentation
if (UNIX AND NOT APPLE)
  add_subdirectory("docs")
endif()

######################################################################
# General packaging / installation
set(CPACK_PACKAGE_VENDOR "Daniel Wagenaar")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "NotedELN - an Electronic Lab Notebook")
set(CPACK_PACKAGE_DESCRIPTION
  "NotedELN is an Electronic Lab Notebook that lets you focus on note taking.
NotedELN supports text, images, and basic graphical annotations. 
NotedELN makes safeguarding your notebook entries its number one priority 
and is extremely stable.")
set(CPACK_PACKAGE_EXECUTABLES "notedeln;NotedELN")

if (WIN32)
  # NSIS packaging - to be updated
  include(WinPack.CMakeLists.txt)
elseif (APPLE)
  include(MacDMG.CMakeLists.txt)
elseif (UNIX)
  include(UnixInstall.CMakeLists.txt)
  include(DebPack.CMakeLists.txt)
endif()

include(CPack)

=== debian/changelog ===
eln (1.5.0-3) unstable; urgency=medium

  * Restrict architecture to those for which qt6-webengine-dev is
    available (closes: #1040857). See also bug 1038125. This should be
    relaxed as qt6-webengine-dev is ported.

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 21 Jul 2023 19:42:38 +0200

eln (1.5.0-2) unstable; urgency=medium

  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 08 Jun 2023 15:08:21 -0000

eln (1.5.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on asciidoc, docbook-xml,
      docbook-xsl, libqt5svg5-dev, libqt5webkit5-dev, qtbase5-dev,
      qtmultimedia5-dev, qttools5-dev-tools, texlive-fonts-recommended,
      texlive-latex-base, texlive-latex-extra, texlive-latex-recommended and
      xsltproc.

  [ Barak A. Pearlmutter ]
  * New upstream release
  * Swizzle from qt5 to qt6
  * Bump policy version

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 24 Mar 2023 10:06:27 +0000

=== debian/control ===
--- 
+++ 
@@ -6,26 +6,26 @@
 	   Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper-compat (= 13),
 		cmake,
-		qtbase5-dev (>= 5.5),
-		qttools5-dev-tools (>= 5.5), libqt5webkit5-dev (>= 5.5),
-		qtmultimedia5-dev (>= 5.5),
-		asciidoc (>= 8.6.0), libqt5svg5-dev (>= 5.5),
-		xsltproc (>= 1.0),
-		docbook-xml (>= 4.0), docbook-xsl (>= 1.0),
-		inkscape,
-		texlive-latex-base (>= 2017),
-		texlive-fonts-recommended (>= 2017),
-		texlive-latex-extra (>= 2017),
-		texlive-latex-recommended (>= 2017),
-		biber
-Standards-Version: 4.6.0
+		qt6-base-dev,
+		qt6-tools-dev,
+		qt6-webengine-dev, qt6-multimedia-dev, qt6-svg-dev, qt6-pdf-dev,
+		qt6-declarative-dev,
+		qml6-module-qtdatavisualization,
+		qml6-module-qt-labs-lottieqt,
+		qml6-module-qtcharts,
+		qml6-module-qtwebengine-controlsdelegates,
+		qml6-module-qtwebengine,
+		qml6-module-qtquick3d-spatialaudio,
+		sphinx,
+		asciidoc,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://www.danielwagenaar.net/eln
+Homepage: https://www.danielwagenaar.net/eln
 Vcs-Git: https://salsa.debian.org/science-team/eln.git
 Vcs-Browser: https://salsa.debian.org/science-team/eln
 
 Package: notedeln
-Architecture: any
+Architecture: amd64 arm64 armhf i386
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: git
 Description: Electronic Lab Notebook called NotedELN

## eln 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,8 @@
 
 ######################################################################
 # Set the project name and version
-project(NotedELN VERSION 1.5.0)
+project(NotedELN VERSION 1.5.2)
+
 set(CMAKE_PROJECT_HOMEPAGE_URL "http://danielwagenaar.net/eln")
 
 ######################################################################
@@ -29,8 +30,9 @@
 set(CMAKE_AUTORCC ON)
 set(CMAKE_AUTOUIC ON)
 find_package(Qt6
-  COMPONENTS Widgets Network Svg PrintSupport Multimedia MultimediaWidgets
-  REQUIRED)
+  REQUIRED COMPONENTS Widgets Network Svg PrintSupport
+  OPTIONAL_COMPONENTS Multimedia MultimediaWidgets
+  )
 
 ######################################################################
 # Add the executables
@@ -45,8 +47,12 @@
 target_link_libraries(notedeln Qt6::Network)
 target_link_libraries(notedeln Qt6::Svg)
 target_link_libraries(notedeln Qt6::PrintSupport)
-target_link_libraries(notedeln Qt6::Multimedia)
-target_link_libraries(notedeln Qt6::MultimediaWidgets)
+if(TARGET Qt6::Multimedia)
+  target_link_libraries(notedeln Qt6::Multimedia)
+endif()
+if(TARGET Qt6::MultimediaWidgets)
+  target_link_libraries(notedeln Qt6::MultimediaWidgets)
+endif()
 
 if (WIN32)
   target_link_libraries(notedeln secur32.lib)

=== src/AutoNote/CMakeLists.txt ===
# Automatically generated by updatesources.sh

target_sources(notedeln PRIVATE src/AutoNote/AN_Biblio.h )
target_sources(notedeln PRIVATE src/AutoNote/AN_Pubmed.h )
target_sources(notedeln PRIVATE src/AutoNote/AutoNote.h )
target_sources(notedeln PRIVATE src/AutoNote/AN_Biblio.cpp )
target_sources(notedeln PRIVATE src/AutoNote/AN_Pubmed.cpp )
target_sources(notedeln PRIVATE src/AutoNote/AutoNote.cpp )

=== debian/changelog ===
eln (1.5.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:45:36 +1100

eln (1.5.2-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:51:27 +0000

eln (1.5.2-1) unstable; urgency=medium

  * New upstream release
  * Build scripts now make Qt6 Multimedia stuff optional. But, let's just
    require it anyway and let the porters worry about it.

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 08 Aug 2023 14:38:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,17 @@
 Source: eln
 Section: editors
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Daniel Wagenaar <daw@caltech.edu>,
 	   Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper-compat (= 13),
 		cmake,
 		qt6-base-dev,
 		qt6-tools-dev,
-		qt6-webengine-dev, qt6-multimedia-dev, qt6-svg-dev, qt6-pdf-dev,
+		qt6-webengine-dev,
+		qt6-multimedia-dev,
+		qt6-svg-dev, qt6-pdf-dev,
 		qt6-declarative-dev,
 		qml6-module-qtdatavisualization,
 		qml6-module-qt-labs-lottieqt,
@@ -25,7 +28,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/eln
 
 Package: notedeln
-Architecture: amd64 arm64 armhf i386
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: git
 Description: Electronic Lab Notebook called NotedELN
